--- a/src/rgw/CMakeLists.txt	2025-05-11 05:51:55.174757024 -0000
+++ b/src/rgw/CMakeLists.txt	2025-05-11 06:12:49.210710316 -0000
@@ -272,6 +272,7 @@
 target_link_libraries(rgw_common
   PRIVATE
     global
+    boost_process
     cls_2pc_queue_client
     cls_cmpomap_client
     cls_lock_client